<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class V10 extends CI_Controller
{

    private $cat_ids;

    function __construct()
    {
        error_reporting(0);
        parent::__construct();
        //header('Access-Control-Allow-Origin: '.$_SERVER['HTTP_ORIGIN']);
        header('Content-Type: application/json');
        $this->load->model('v10_model');

        $this->cat_ids = array();
        $this->sub_cats = '';

    }

    public function index()
    {
        echo json_encode(array('status' => 200, 'message' => 'Hello'));
//        $this->load->view('common/header');
//        $this->load->view('home');
//        $this->load->view('common/footer');
    }

    public function library()
    {
        if ($this->input->post()) {
            $id = $this->input->post('library_id');

            if ($id != '') {
                $this->db->where('id', $id);
                $q = $this->db->get('tb_library');

                $result = array('status' => 200, 'message' => 'Done', 'entries' => $q->row());
            } else {

                $q = $this->db->get('tb_library');

                $result = array('status' => 200, 'message' => 'Done', 'entries' => $q->result());
            }


        } else {

            $result = array('status' => 404, 'message' => 'Undefined');
        }

        echo json_encode($result);
    }


    function register()
    {

        if ($this->input->post()) {
            if (strpos('/', $this->input->post('birth_date')) or strpos('-', $this->input->post('birth_date'))) {
                $birth_date = explode('/', $this->input->post('birth_date'));
                $birth_date = $birth_date[2] . '-' . $birth_date[1] . '-' . $birth_date[0];

            } else {

                $birth_date = date('Y-m-d', strtotime($this->input->post('birth_date')));
            }

            $salt = $this->auth->generateRandomString(22);

            $options = [
                'salt' => $salt,
                'cost' => 12
            ];

            $hash = password_hash($this->input->post('password'), PASSWORD_DEFAULT, $options);

            $data['employee_id'] = $this->input->post('employee_id');
            $data['prefix'] = $this->input->post('prefix');
            $data['first_name_en'] = $this->input->post('first_name_en');
            $data['last_name'] = $this->input->post('last_name');
            $data['nick_name'] = $this->input->post('nick_name');
            $data['gender'] = $this->input->post('gender');
            $data['position_name_alias'] = $this->input->post('position_name_alias');
            $data['office'] = $this->input->post('office');
            $data['company_name'] = $this->input->post('company_name');
            $data['company_code'] = $this->input->post('company_code');

            $data['username'] = $this->input->post('username');
            $data['password'] = $hash;
            $data['salt'] = $salt;
            $data['first_name'] = $this->input->post('first_name');
            $data['last_name'] = $this->input->post('last_name');
            $data['email'] = $this->input->post('email');
            $data['created_date'] = date('Y-m-d H:i:s');
            $data['modify_date'] = date('Y-m-d H:i:s');
            $data['birth_date'] = $birth_date;
            $data['auth'] = $this->input->post('auth');
            $data['library'] = $this->input->post('library');
            $data['role'] = $this->input->post('role') == "" ? 'user' : $this->input->post('role');
            $data['district_id'] = $this->input->post('district_id') == "" ? NULL : $this->input->post('district_id');
            $data['organization_id'] = $this->input->post('organization_id') == "" ? NULL : $this->input->post('organization_id');
            $data['position_id'] = $this->input->post('position_id') == "" ? NULL : $this->input->post('position_id');
            $data['level_id'] = $this->input->post('level_id');

            $check_username = $this->db->get_where('tb_user',
                array(
                    'username' => $data['username'],
                    'library' => $data['library']
                )
            );

            if ($check_username->num_rows() > 0) {
                $result = array('status' => 500, 'message' => 'Username is already exist.');
                echo json_encode($result);
                exit();
            }

            $check_email = $this->db->get_where('tb_user', array('email' => $data['email']));
            if ($check_email->num_rows() > 0) {
                $result = array('status' => 500, 'message' => 'Email address is already exist.');
                echo json_encode($result);
                exit();
            }

            /* email confirm account */

            $confirm = $this->db->get_where('tb_library', array('id' => $this->input->post('library')));

            $data['email_confirm'] = $confirm->row()->email_confirm == 'off' ? 1 : 0;


            if (LIBRARY_ID == 28) {

                $data['csr_code_position'] = $this->input->post('csr_code_position');

            }

            if ($this->db->insert('tb_user', $data)) {
                if ($confirm->row()->email_confirm == 'on') {

                    $this->send_confirm_email($this->input->post('first_name'), $this->input->post('last_name'), $this->input->post('email'), $salt, $this->db->insert_id());

                    $result = array('status' => 200, 'message' => 'Done', 'entries' => array('user_id' => $this->db->insert_id()));

                    echo json_encode($result);

                } else {

                    $this->load->library('user_agent');

                    $member = $this->db->get_where('tb_user', array('id' => $this->db->insert_id()));
                    $user_data['first_name'] = $member->row()->first_name;
                    $user_data['user_id'] = $member->row()->id;
                    $user_data['last_name'] = $member->row()->last_name;
                    $user_data['email'] = $member->row()->email;
                    $user_data['username'] = $member->row()->username;
                    $user_data['library'] = $member->row()->library;
                    $user_data['birth_date'] = ($member->row()->birth_date <> '' ? strtotime($member->row()->birth_date) : '');
                    $user_data['created_date'] = strtotime($member->row()->created_date);
                    $user_data['modify_date'] = strtotime($member->row()->modify_date);
                    $user_data['session'] = $this->auth->generateRandomString('30');
                    $user_data['library'] = $member->row()->library;
                    $user_data['role'] = $member->row()->role;
                    $user_data['district_id'] = $member->row()->district_id;
                    $user_data['position_id'] = $member->row()->position_id;
                    $user_data['position_name'] = $this->getPosition($member->row()->position_id);
                    $user_data['organization_id'] = $member->row()->organization_id;
                    $user_data['organization_name'] = $this->getDepartment($member->row()->organization_id);
                    $user_data['company_name'] = $member->row()->company_name;
                    $user_data['company_code'] = $member->row()->company_code;
                    $user_data['office'] = $member->row()->position_name_alias;
                    $user_data['position_name_alias'] = $member->row()->position_name_alias;
                    $user_data['auth'] = $member->row()->auth;
                    $user_data['nick_name'] = $member->row()->nick_name;
                    $user_data['gender'] = $member->row()->gender;
                    $user_data['prefix'] = $member->row()->prefix;
                    $user_data['position_level_name'] = $member->row()->position_level_name;
                    $user_data['profile_picture'] = $member->row()->profile_picture;

                    // Clear session
                    $this->db->where('user_id', $member->row()->id);
                    $this->db->where('status', 1);
                    $this->db->delete('tb_session');

                    // Store Session.
                    $this->db->insert('tb_session', array('user_id' => $member->row()->id, 'session' => $user_data['session'], 'user_agent' => $this->agent->agent_string(), 'library' => $member->row()->library, 'created_date' => date('Y-m-d H:i:s'), 'expire_date' => date('Y-m-d H:i:s', strtotime('+1 years')), 'token' => $token, 'status' => 1));

                    $result = array('status' => 200, 'message' => 'Done', 'entries' => $user_data);
                    echo json_encode($result);
                    //$this->login($data['username'], $this->input->post('password'), $data['library']);

                }
            }


        }

    }

    function edit_profile()
    {

        if ($this->input->post()) {
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');

            $this->checkSession($session, $user_id);

            if ($this->input->post('password') != '') {
                $salt = $this->auth->generateRandomString(22);
                $options = [
                    'salt' => $salt,
                    'cost' => 12
                ];
                $hash = password_hash($this->input->post('password'), PASSWORD_DEFAULT, $options);

                $data['password'] = $hash;
                $data['salt'] = $salt;

            }

            $data['first_name'] = $this->input->post('first_name');
            $data['last_name'] = $this->input->post('last_name');
            $data['email'] = $this->input->post('email');
            $data['modify_date'] = date('Y-m-d H:i:s');

            $this->db->where('id', $user_id);
            $update = $this->db->update('tb_user', $data);

            if ($update) {
                $result = array('status' => 200, 'message' => 'Done');
                echo json_encode($result);
                exit();
            }
        }
    }


    function login()
    {

        if ($this->input->post()) {
            $this->load->library('user_agent');
            $username = $this->input->post('username');
            $password = $this->input->post('password');
            $library_id = $this->input->post('library_id');
            $token = $this->input->post('token');

            $administrator = $this->checkAdministrator($username, $password);

            /*For check administrator */
//        $new = 0;

            if (!empty($administrator)) {

                $member = $administrator;

            } else {

                /*For check user Login*/
                $member = $this->db->get_where('tb_user', array(
                    'username' => $username,
                    'library' => $library_id
                ));

//            if($member->num_rows() == 0) {
//                $new = 1;
//                $member = $this->db->get_where('tb_user_v2', array(
//                    'username' => $username,
//                    'library' => $library_id
//                ));
//            }
            }

            if ($member->num_rows() > 0) {
                $chkdist_active = $this->db->get_where('tb_district2', array(
                    'district_id' => $member->row()->district_id,
                    'active' => '1'
                ));

                if ($chkdist_active->num_rows() > 0) {

                    $d_active = 1;

                } else {

                    $d_active = 0;
                }


                if ($member->row()->auth == 'db') {

                    $options = [
                        'salt' => $member->row()->salt,
                        'cost' => 12
                    ];

                    $hash = password_hash($password, PASSWORD_DEFAULT, $options);

                    if ($member->row()->password == $hash) {

                        if ($member->row()->email_confirm) {

                            $user_data['first_name'] = $member->row()->first_name;
                            $user_data['user_id'] = $member->row()->id;
                            $user_data['last_name'] = $member->row()->last_name;
                            $user_data['email'] = $member->row()->email;
                            $user_data['username'] = $member->row()->username;
                            $user_data['library'] = $member->row()->library;
                            $user_data['birth_date'] = ($member->row()->birth_date <> '' ? strtotime($member->row()->birth_date) : '');
                            $user_data['created_date'] = strtotime($member->row()->created_date);
                            $user_data['modify_date'] = strtotime($member->row()->modify_date);
                            $user_data['session'] = $this->auth->generateRandomString('30');
                            $user_data['library'] = $member->row()->library;
                            $user_data['role'] = $member->row()->role;
                            $user_data['district_id'] = $member->row()->district_id;
                            $user_data['position_id'] = $member->row()->position_id;
                            $user_data['position_name'] = $this->getPosition($member->row()->position_id);
                            $user_data['organization_id'] = $member->row()->organization_id;
                            $user_data['organization_name'] = $this->getDepartment($member->row()->organization_id);
                            $user_data['company_name'] = $member->row()->company_name;
                            $user_data['company_code'] = $member->row()->company_code;
                            $user_data['office'] = $member->row()->position_name_alias;
                            $user_data['position_name_alias'] = $member->row()->position_name_alias;
                            $user_data['auth'] = $member->row()->auth;
                            $user_data['nick_name'] = $member->row()->nick_name;
                            $user_data['gender'] = ($member->row()->gender == '' ? '' : $member->row()->gender);
                            $user_data['prefix'] = $member->row()->prefix;
                            $user_data['position_level_name'] = $member->row()->position_level_name;
                            $user_data['profile_picture'] = $member->row()->profile_picture;
                            $user_data['active'] = $member->row()->active;
//                $user_data['new'] = $new;

                            // Clear session

                            if ($library_id == 31 or $library_id == 29 or $library_id == 1 or $library_id == 35) {

                            } else {
                                $this->db->where('user_id', $member->row()->id);
                                $this->db->where('status', 1);
                                $this->db->delete('tb_session');
                            }

                            if ($d_active) {

                                if (LIBRARY_ID != 28) {

                                    if ($member->row()->active == 1) {

                                        // Store Session.
                                        $this->db->insert('tb_session', array('user_id' => $member->row()->id, 'session' => $user_data['session'], 'user_agent' => $this->agent->agent_string(), 'library' => $member->row()->library, 'created_date' => date('Y-m-d H:i:s'), 'expire_date' => date('Y-m-d H:i:s', strtotime('+1 years')), 'token' => $token, 'status' => 1));


                                        $result = array('status' => 200, 'message' => 'Done', 'entries' => $user_data);

                                    } else {


                                        $result = array('status' => 403, 'message' => 'Account Inactive');
                                    }

                                } else {

                                    // Store Session.
                                    $this->db->insert('tb_session', array('user_id' => $member->row()->id, 'session' => $user_data['session'], 'user_agent' => $this->agent->agent_string(), 'library' => $member->row()->library, 'created_date' => date('Y-m-d H:i:s'), 'expire_date' => date('Y-m-d H:i:s', strtotime('+1 years')), 'token' => $token, 'status' => 1));
                                    $result = array('status' => 200, 'message' => 'Done', 'entries' => $user_data);

                                }

                            } else {

                                $result = array('status' => 403, 'message' => 'Inactive');
                            }

                        } else {

                            $result = array('status' => 40, 'message' => 'Please Activate Your Account From Email Before Sign in');
                        }

                    } else {

                        $result = array('status' => 403, 'message' => 'Invalid username or password');
                    }

                } else {

                    $ldap = $this->v10_model->checkAD($library_id);

                    if (!empty($ldap)) {

                        $ldapconn = ldap_connect($ldap->server) or die(json_encode(array('status' => 500, 'message' => 'Unable to connect to AD server.')));
                        if ($ldapconn) {
                            ldap_set_option($ldapconn, LDAP_OPT_PROTOCOL_VERSION, 3);

                            $ldapbind = @ldap_bind($ldapconn, $username, $password);
                            if ($ldapbind) {
                                $result = ldap_search($ldapconn, $ldap->dn, 'userprincipalname=' . $username) or die (array('status' => 404, 'message' => 'Not found.'));
                                $entries = ldap_get_entries($ldapconn, $result);
                                if ($entries['count'] > 0) {

                                    $user_data['user_id'] = $member->row()->id;
                                    $user_data['first_name'] = $member->row()->first_name;
                                    $user_data['last_name'] = $member->row()->last_name;
                                    $user_data['email'] = $member->row()->email;
                                    $user_data['username'] = $member->row()->username;
                                    $user_data['library'] = $member->row()->library;
                                    $user_data['birth_date'] = strtotime($member->row()->birth_date);
                                    $user_data['created_date'] = strtotime($member->row()->created_date);
                                    $user_data['modify_date'] = strtotime($member->row()->modify_date);
                                    $user_data['session'] = $this->auth->generateRandomString('30');
                                    $user_data['role'] = $member->row()->role;
                                    $user_data['district_id'] = $member->row()->district_id;
                                    $user_data['gender'] = ($member->row()->gender == '' ? '' : $member->row()->gender);

                                    // Clear session
                                    $this->db->where('user_id', $member->row()->id);
                                    $this->db->where('status', 1);
                                    $this->db->delete('tb_session');

                                    // Store Session.
                                    $this->db->insert('tb_session', array('user_id' => $member->row()->id, 'session' => $user_data['session'], 'user_agent' => $this->agent->agent_string(), 'library' => $member->row()->library, 'created_date' => date('Y-m-d H:i:s'), 'expire_date' => date('Y-m-d H:i:s', strtotime('+1 years')), 'token' => $token, 'status' => 1));

                                    $result = array('status' => 200, 'message' => 'Done', 'entries' => $user_data);
                                }

                            } else {

                                $result = array('status' => 403, 'message' => 'Invalid username or password');
                            }
                        }

                    } else {
                        $result = array('status' => 500, 'message' => 'Cannot Connect LDAP (SERVER)');
                    }/*end if checkAD*/

                }


            } else {
                $result = array('status' => 403, 'message' => 'Invalid username or password');
            }

        } else {
            $result = array('status' => 400, 'message' => 'Bad Request');
        }

        echo json_encode($result);
        exit();
    }

    function check_session()
    {
        if ($this->input->post()) {
            $session = $this->input->post('session');
            $user_id = $this->input->post('user_id');

            $session = $this->db->get_where('tb_session', array('user_id' => $user_id, 'session' => $session));
            if ($session->num_rows() > 0) {
                $data['expiry_date'] = strtotime($session->row()->expire_date);
                $data['status'] = (strtotime(date('Y-m-d H:i:s')) > $data['expiry_date'] ? 'Expired' : 'Active');
                $result = array('status' => 200, 'message' => 'Done', 'entries' => $data);
            } else {
                $result = array('status' => 404, 'message' => 'Session not found');
            }
        } else {
            $result = array('status' => 500, 'message' => 'Unknown Action');
        }

        echo json_encode($result);
        exit();
    }

    function checkAdministrator($username = null, $password = null)
    {

        $administrator = $this->db->get_where('tb_user', array(
            'username' => $username,
            'role' => 1
        ));

        if ($administrator->num_rows() > 0) {
            $options = [
                'salt' => $administrator->row()->salt,
                'cost' => 12
            ];

            $hash = password_hash($password, PASSWORD_DEFAULT, $options);

            if ($administrator->row()->password == $hash) {

                return $administrator;
            }
        }
    }

    function checkAdministrator2($username = null, $password = null)
    {
        $administrator = $this->db->get_where('tb_user_v2', array(
            'username' => $username,
            'role' => 1
        ));

        if ($administrator->num_rows() > 0) {
            $options = [
                'salt' => $administrator->row()->salt,
                'cost' => 12
            ];

            $hash = password_hash($password, PASSWORD_DEFAULT, $options);

            if ($administrator->row()->password == $hash) {
                return $administrator;
            }
        }
    }


    function logout()
    {
        if ($this->input->post()) {
            $session = $this->input->post('session');
            $user_id = $this->input->post('user_id');

            if ($session == '') {
                $result = array('status' => 500, 'message' => 'Session required.');

                echo json_encode($result);
                exit();
            }

            $this->db->where('session', $session);
            $this->db->where('user_id', $user_id);
            $this->db->delete('tb_session');

            $result = array('status' => 200, 'message' => 'Done');

            echo json_encode($result);
        }
    }

    function logout2()
    {
        if ($this->input->post()) {
            $session = $this->input->post('session');
            $user_id = $this->input->post('user_id');

            if ($session == '') {
                $result = array('status' => 500, 'message' => 'Session required.');

                echo json_encode($result);
                exit();
            }

            $this->db->where('session', $session);
            $this->db->where('user_id', $user_id);
            $this->db->delete('tb_session');

            $result = array('status' => 200, 'message' => 'Done');

            echo json_encode($result);
        }
    }

    function user_info()
    {
        if ($this->input->post()) {
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');

            $this->checkSession($session, $user_id);

            $member = $this->db->get_where('tb_user', array('id' => $user_id));
            if ($member->num_rows() > 0) {
                $user_data['employee_id'] = $member->row()->employee_id;
                $user_data['first_name'] = $member->row()->first_name;
                $user_data['last_name'] = $member->row()->last_name;
                $user_data['first_name_en'] = $member->row()->first_name_en;
                $user_data['last_name_en'] = $member->row()->last_name_en;
                $user_data['email'] = $member->row()->email;
                $user_data['username'] = $member->row()->username;
                $user_data['library'] = $member->row()->library;
                $user_data['level_id'] = $member->row()->level_id;
                $user_data['profile_picture'] = $member->row()->profile_picture;
                $user_data['birth_date'] = $member->row()->birth_date;
                $user_data['created_date'] = strtotime($member->row()->created_date);
                $user_data['modify_date'] = strtotime($member->row()->modify_date);
                $user_data['position_id'] = $member->row()->position_id;
                $user_data['position_name'] = $this->getPosition($member->row()->position_id);
                $user_data['organization_id'] = $member->row()->organization_id;
                $user_data['organization_name'] = $this->getDepartment($member->row()->organization_id);
                $user_data['company_name'] = $member->row()->company_name;
                $user_data['company_code'] = $member->row()->company_code;
                $user_data['office'] = $member->row()->position_name_alias;
                $user_data['position_name_alias'] = $member->row()->position_name_alias;
                $user_data['auth'] = $member->row()->auth;
                $user_data['nick_name'] = $member->row()->nick_name;
                $user_data['gender'] = $member->row()->gender;
                $user_data['prefix'] = $member->row()->prefix;
                $user_data['position_level_name'] = $member->row()->position_level_name;
                $user_data['profile_picture'] = $member->row()->profile_picture;

                $result = array('status' => 200, 'message' => 'Done', 'entries' => $user_data);
            }

            echo json_encode($result);
        }
    }

    function user_info2()
    {
        if ($this->input->post()) {
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $this->checkSession($session, $user_id);

            $member = $this->db->get_where('tb_user_v2', array('id' => $user_id));
            if ($member->num_rows() > 0) {
                $user_data['employee_id'] = $member->row()->employee_id;
                $user_data['first_name'] = $member->row()->first_name;
                $user_data['last_name'] = $member->row()->last_name;
                $user_data['first_name_en'] = $member->row()->first_name_en;
                $user_data['last_name_en'] = $member->row()->last_name_en;
                $user_data['email'] = $member->row()->email;
                $user_data['username'] = $member->row()->username;
                $user_data['library'] = $member->row()->library;
                $user_data['level_id'] = $member->row()->level_id;
                $user_data['profile_picture'] = $member->row()->profile_picture;
                $user_data['birth_date'] = $member->row()->birth_date;
                $user_data['created_date'] = strtotime($member->row()->created_date);
                $user_data['modify_date'] = strtotime($member->row()->modify_date);
                $user_data['position_id'] = $member->row()->position_id;
                $user_data['position_name'] = $this->getPosition2($member->row()->position_id);
                $user_data['organization_id'] = $member->row()->organization_id;
                $user_data['organization_name'] = $this->getDepartment2($member->row()->organization_id);
                $user_data['company_name'] = $member->row()->company_name;
                $user_data['company_code'] = $member->row()->company_code;
                $user_data['office'] = $member->row()->position_name_alias;
                $user_data['position_name_alias'] = $member->row()->position_name_alias;
                $user_data['auth'] = $member->row()->auth;
                $user_data['nick_name'] = $member->row()->nick_name;
                $user_data['gender'] = $member->row()->gender;
                $user_data['prefix'] = $member->row()->prefix;
                $user_data['position_level_name'] = $member->row()->position_level_name;
                $user_data['profile_picture'] = $member->row()->profile_picture;

                $result = array('status' => 200, 'message' => 'Done', 'entries' => $user_data);
            }

            echo json_encode($result);
        }
    }


    private function getPosition($id = null)
    {

        $position = $this->db->get_where('tb_position', array('id' => $id));

        if ($position->num_rows() > 0) {
            return $position->row()->position_name;
        }
    }

    private function getDepartment($id = null)
    {

        $position = $this->db->get_where('tb_organization', array('id' => $id));

        if ($position->num_rows() > 0) {
            return $position->row()->organization_name;
        }
    }


    private function send_confirm_email($first_name, $last_name, $email, $salt, $user_id)
    {

        if (!empty($email)) {

            $member = $this->db->get_where('tb_user', array('user_id' => $user_id))->row();

            require_once APPPATH . "/third_party/PHPMailer/PHPMailerAutoload.php";

            $edm = '<html><head><meta charset="utf-8" /></head>';
            $edm .= '<body>';
            $edm .= '<table width="800">';
            $edm .= '<tr>';
            $edm .= '<td>Hello' . $first_name . '  ' . $last_name . ', <br/><br/></td>';
            $edm .= '</tr>';
            $edm .= '<tr>';
            $edm .= '<td>We received a request to activated your Wisimo account. We\' re here to help!</td>';
            $edm .= '</tr>';
            $edm .= '<tr>';
            $edm .= '<td>Click on the link to active your account.  <a href="' . base_url() . 'home/email_confirm/' . $salt . '">Click to Active</a></td>';
            $edm .= '</tr>';
            $edm .= '<tr>';
            $edm .= '<td>Cheers,<br/>Wisimo</td>';
            $edm .= '</tr>';
            $edm .= '</table>';
            $edm .= '</body>';
            $edm .= '</html>';

            $setting = $this->db->get_where('tb_email_setting', array('library_id' => $member->library_id))->row();


            $mail = new PHPMailer;
            $mail->CharSet = 'UTF-8';

            if ($setting->smtp == 1) {
                $mail->isSMTP();
            }
            $mail->Host = $setting->host;
            $mail->SMTPAuth = ($setting->auth == 1 ? true : false);

            $mail->setFrom($setting->email, $setting->name);
            $mail->addAddress($email, $first_name . ' ' . $last_name);
            $mail->isHTML(true);

            $mail->Subject = 'Wisimo Activated  Your Account.';
            $mail->Body = $edm;


            if (!$mail->send()) {

                $result = array('status' => 500, 'message' => 'Unable to send mail');

            } else {

                $result = array('status' => 200, 'message' => 'Done', 'entries' => array('user_id' => $user_id));

            }


        } else {

            $result = array('status' => 500, 'message' => 'Email does not exist');
        }

        //echo json_encode($result);
        exit();

    }


    function forget_password()
    {
        if ($this->input->post()) {

            require_once APPPATH . "/third_party/PHPMailer/PHPMailerAutoload.php";

            $email = $this->input->post('email');
            $library_id = $this->input->post('library_id');

            $this->db->where('library', $library_id);
            $member = $this->db->get_where('tb_user', array('email' => $email));

            if ($member->num_rows() > 0) {
                $reset_key = $this->auth->generateRandomString(20);
                $edm = '<html><head><meta charset="utf-8" /></head>';
                $edm .= '<body>';
                $edm .= '<table width="800">';
                $edm .= '<tr>';
                $edm .= '<td>Hello' . $member->row()->first_name . '  ' . $member->row()->last_name . ', <br/><br/></td>';
                $edm .= '</tr>';
                $edm .= '<tr>';
                $edm .= '<td>We received a request to reset your password for your Wisimo Account. We\' re here to help!</td>';
                $edm .= '</tr>';
                $edm .= '<tr>';
                $edm .= '<td>Click on the link to reset password.  <a href="' . base_url() . 'home/reset_password/' . $reset_key . '">Click to Reset</a></td>';
                $edm .= '</tr>';
                $edm .= '<tr>';
                $edm .= '<td>Cheers,<br/>Wisimo</td>';
                $edm .= '</tr>';
                $edm .= '</table>';
                $edm .= '</body>';
                $edm .= '</html>';

                $setting = $this->db->get_where('tb_email_setting', array('library_id' => $library_id))->row();


                $mail = new PHPMailer;
                $mail->CharSet = 'UTF-8';

                if ($setting->smtp == 1) {
                    $mail->isSMTP();
                }
                $mail->Host = $setting->host;
                $mail->SMTPAuth = ($setting->auth == 1 ? true : false);

                $mail->setFrom($setting->email, $setting->name);
                $mail->addAddress($email, $member->row()->first_name . ' ' . $member->row()->last_name);
                $mail->isHTML(true);

                $mail->Subject = 'Wisimo Reset Password Request.';
                $mail->Body = $edm;


                if (!$mail->send()) {

                    $result = array('status' => 500, 'message' => 'Mailer Error: ' . $mail->ErrorInfo);

                } else {

                    $this->db->delete('tb_reset', array('user_id' => $member->row()->id));
                    $data['reset_key'] = $reset_key;
                    $data['user_id'] = $member->row()->id;
                    $data['email'] = $email;
                    $data['request_date'] = date('Y-m-d H:i:s');
                    $data['expire_date'] = date('Y-m-d H:i:s', strtotime('+1 weeks'));
                    $this->db->insert('tb_reset', $data);

                    $result = array('status' => 200, 'message' => 'Done');
                }


            } else {

                $result = array('status' => 500, 'message' => 'Email does not exist');
            }


            echo json_encode($result);

        }
    }

    function forget_password2()
    {
        if ($this->input->post()) {
            require_once APPPATH . "/third_party/PHPMailer/PHPMailerAutoload.php";

            $email = $this->input->post('email');
            $library_id = $this->input->post('library_id');

            $this->db->where('library', $library_id);
            $member = $this->db->get_where('tb_user_v2', array('email' => $email));

            if ($member->num_rows() > 0) {
                $reset_key = $this->auth->generateRandomString(20);
                $edm = '<html><head><meta charset="utf-8" /></head>';
                $edm .= '<body>';
                $edm .= '<table width="800">';
                $edm .= '<tr>';
                $edm .= '<td>สวัสดีคุณ'.' ' . $member->row()->first_name . '  ' . $member->row()->last_name . ', <br/></td>';
                $edm .= '</tr>';
                $edm .= '<tr>';
                $edm .= '<td>เราได้รับคำขอที่จะเปลี่ยน Password ให้คุณ ดังนั้นเราได้ส่ง E-mail นี้เพื่อให้คุณทำการเปลี่ยน Password โดยการคลิก  <a href="' . base_url() . 'home/reset_password2/' . $reset_key . '">Click to Reset</a> นี้ หากคุณไม่ได้ทำการขอการ Reset นี้ กรุณาลบ E-mail นี้ทิ้งได้ แล้วระบบจะไม่ทำการใดๆ<br/></td>';
                $edm .= '</tr>';
                $edm .= '<tr>';
                $edm .= '<td><br/>ด้วยความเคารพยิ่ง<br/>System Admin.<br/><br/></td>';
                $edm .= '</tr>';
                $edm .= '<tr>';
                $edm .= '<td>Dear'.' ' . $member->row()->first_name . '  ' . $member->row()->last_name . ', <br/></td>';
                $edm .= '</tr>';
                $edm .= '<tr>';
                $edm .= '<td>We received a request to reset your password. We\'re here to help. Please click on the link to reset password.  <a href="' . base_url() . 'home/reset_password2/' . $reset_key . '">Click to Reset</a> If you did not make any request, please ignore this e-mail and delete out<br/></td>';
                $edm .= '</tr>';
                $edm .= '<tr>';
                $edm .= '<td><br/>Best Regards,<br/>System Admin.</td>';
                $edm .= '</tr>';
                $edm .= '</table>';
                $edm .= '</body>';
                $edm .= '</html>';

                $c = array('library_id' => $library_id, 'setcurrent' => 1);
                $q = $this->db->get_where('tb_email_setting', $c);

                if ($q->num_rows()) {
                    foreach ($q->result_array() as $r) {
                        $host = $r['host'];
                        $name_host = $r['name'];
                        $email_host = $r['email'];

                        if ($host == 'localhost') {
                            $port = "no";
                            $username = "no";
                            $password = "no";
                            $password = "no";
                        } else {
                            $port = $r['port'];
                            $username = $r['username_c'];
                            $password = $r['password_c'];
                        }
                    }
                }

                // Start Sending
                $mail = new PHPMailer;
                $mail->CharSet = 'UTF-8';

                if ($host == 'localhost') {
                    $mail->Host = 'localhost';
                    $mail->SMTPAuth = 0;
                    $mail->setFrom($email_host, $name_host);
                    $mail->addAddress($email, $email);
                    $mail->isHTML(true);
                } else {
                    $mail->isSMTP();
                    $mail->SMTPAuth = true;
                    $mail->SMTPSecure = 'tsl';
                    $mail->Host = $host;
                    $mail->Mailer = "smtp";
                    $mail->Port = $port;
                    $mail->Username = $username;
                    $mail->Password = $password;
                    $mail->setFrom($email_host, $name_host);
                }

                $mail->addAddress($email, $email);
                $mail->isHTML(true);

                $mail->Subject = 'Your Reset Password Request.';
                $mail->Body = $edm;


                if (!$mail->send()) {
                    $result = array('status' => 500, 'message' => 'Mailer Error: ' . $mail->ErrorInfo);
                } else {
                    $this->db->delete('tb_reset', array('user_id' => $member->row()->id));
                    $data['reset_key'] = $reset_key;
                    $data['user_id'] = $member->row()->id;
                    $data['email'] = $email;
                    $data['request_date'] = date('Y-m-d H:i:s');
                    $data['expire_date'] = date('Y-m-d H:i:s', strtotime('+1 weeks'));
                    $this->db->insert('tb_reset', $data);

                    $result = array('status' => 200, 'message' => 'Done');
                }
            } else {
                $result = array('status' => 500, 'message' => 'Email does not exist');
            }

            echo json_encode($result);
        }
    }


    function reset_password()
    {
        if ($this->input->post()) {

            $reset_key = $this->input->post('reset_key');

            $reset = $this->db->get_where('tb_reset', array('reset_key' => $reset_key));
            if ($reset->num_rows() > 0) {
                $salt = $this->auth->generateRandomString(22);
                $options = [
                    'salt' => $salt,
                    'cost' => 12
                ];

                $hash = password_hash($this->input->post('password'), PASSWORD_DEFAULT, $options);

                $this->db->where('id', $reset->row()->user_id);
                $this->db->update('tb_user', array('password' => $hash, 'salt' => $salt));

                $this->db->delete('tb_reset', array('id' => $reset->row()->id));

                $result = array('status' => 200, 'message' => 'Done');

            } else {
                $result = array('status' => 500, 'message' => 'Unknown Reset Key');
            }
        }
        echo json_encode($result);
    }

    function reset_password2()
    {
        if ($this->input->post()) {
            $reset_key = $this->input->post('reset_key');

            $reset = $this->db->get_where('tb_reset', array('reset_key' => $reset_key));
            if ($reset->num_rows() > 0) {
                $salt = $this->auth->generateRandomString(22);
                $options = [
                    'salt' => $salt,
                    'cost' => 12
                ];

                $hash = password_hash($this->input->post('password'), PASSWORD_DEFAULT, $options);

                $this->db->where('id', $reset->row()->user_id);
                $this->db->update('tb_user_v2', array('password' => $hash, 'salt' => $salt));

                $this->db->delete('tb_reset', array('id' => $reset->row()->id));
                $result = array('status' => 200, 'message' => 'Done');
            } else {
                $result = array('status' => 500, 'message' => 'Unknown Reset Key');
            }
        }

        echo json_encode($result);
    }

    function upload_profile_picture()
    {
        if ($this->input->post()) {

            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');

            $this->checkSession($session, $user_id);

            $file = $_FILES["file"];
            $file_type = explode('.', $file["name"]);

            if (strtolower($file_type[count($file_type) - 1]) == 'jpg' or strtolower($file_type[count($file_type) - 1]) == 'jpeg' or strtolower($file_type[count($file_type) - 1]) == 'png') {
                $member = $this->db->get_where('tb_user', array('id' => $user_id));
                $library = $this->db->get_where('tb_library', array('id' => $member->row()->library));

                if (!file_exists($_SERVER["DOCUMENT_ROOT"] . '/' . $library->row()->library_path . '/profile/')) {
                    @mkdir($_SERVER["DOCUMENT_ROOT"] . '/' . $library->row()->library_path . '/profile/');
                }

                $new_name = $this->auth->generateRandomString(10) . '.' . strtolower($file_type[count($file_type) - 1]);

                if (copy($file["tmp_name"], $_SERVER["DOCUMENT_ROOT"] . '/' . $library->row()->library_path . '/profile/' . $new_name)) {
                    $data['profile_picture'] = $library->row()->library_path . '/profile/' . $new_name;
                    $data['modify_date'] = date('Y-m-d H:i:s');

                    $this->db->where('id', $user_id);
                    $update = $this->db->update('tb_user', $data);

                    if ($update) {
                        @unlink($_SERVER["DOCUMENT_ROOT"] . '/' . $library->row()->library_path . '/profile/' . $member->row()->profile_picture);
                        $result = array('status' => 200, 'message' => 'Done');
                    } else {
                        $result = array('status' => 500, 'message' => 'Unable to update profile.');
                    }

                } else {

                    $result = array('status' => 500, 'message' => 'Unable to upload file');
                }
            } else {

                $result = array('status' => 500, 'message' => $file_type[count($file_type) - 1] . ' is not supported.');
            }
        }

        echo json_encode($result);
    }


    // Book Shelf

    function book_preview()
    {

        $this->load->model('api_book');
        $this->api_book->book_preview($this->input->post());
        exit();
        if ($this->input->post()) {
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $book_id = $this->input->post('book_id');
            $library_id = $this->input->post('library_id');

            $this->db->select('title, cover, preview, description, size, create_date, modify_date');
            $book = $this->db->get_where('tb_book', array('id' => $book_id));


            if ($book->num_rows() > 0) {
                $book = $book->row();

                $book->create_date = strtotime($book->create_date);
                $book->revision = strtotime($book->modify_date);
                $book->size = (string)($book->size == '' ? 0.00 : (float)$book->size);
                $book->cover = ($book->cover == null ? '' : $book->cover);

                if ($book->preview <> '') {
                    $book->preview = explode(',', $book->preview);
                } else {
                    $book->preview = array();
                }

                if ($book->size == 0) {
                    $book->available = false;
                    $message = 'Book is not available.';
                } else {
                    $book->available = true;
                    $message = 'Done';
                }

                $result = array('status' => 200, 'message' => $message, 'entries' => $book);

            } else {
                $result = array('status' => 404, 'message' => 'Book ID Not Found');

            }
        } else {
            $result = array('status' => 404, 'message' => 'Unknown Action');
        }

        echo json_encode($result);
    }

    function book()
    {
        $this->load->model('api_book');
        $this->api_book->book($this->input->post());
        exit();
        if ($this->input->post()) {
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $book_id = $this->input->post('book_id');

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
            }

            $book = $this->db->get_where('tb_book', array('id' => $book_id));

            if ($book->num_rows() > 0) {
                $book = $book->row();

                $this->load->library('user_agent');
                if ($this->agent->platform() == 'iOS' and ($book_id > 99)) {
                    $data = json_decode($book->json_canvas)->data;
                } else {
//                    $data = json_decode($book->json_canvas_ios)->data;
                    $data = json_decode($book->json_canvas)->data;
                }

                $log = array(
                    'user_id' => $user_id,
                    'book_id' => $book_id,
                    'canvas_id' => '',
                    'object_id' => '',
                    'datetime' => date('Y-m-d H:i:s'),
                    'platform' => strtolower($this->agent->platform()),
                    'type' => 'download',
                    'agent' => $this->agent->agent_string()
                );

                $this->db->insert('tb_reader_log', $log);

//            var_dump($data);exit();
                $data->category_id = $book->category_id;
                $category = $this->db->get_where('tb_book_category', array('id' => $book->category_id))->row();
                $data->category_name = $category->category_name;
                $result = array('status' => 200, 'message' => 'Done', 'entries' => $data);
            } else {
                $result = array('status' => 404, 'message' => 'Book ID Not Found');
            }
        } else {
            $result = array('status' => 404, 'message' => 'Unknown Action');
        }

        echo json_encode($result);
    }


    function catalog_list()
    {

        if ($this->input->post()) {
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $catalog_id = $this->input->post('catalog_id');
            $library_id = $this->input->post('library_id');
            $version = $this->input->post('version');
            $platform = $this->input->post('platform');

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);
                $user_group = explode(',', $user->group_viewer);
            } else {
                $user = '';
            }

            $catalog = $this->db->get_where('tb_catalog', array('id' => $catalog_id))->row();

            $arr_data = array();
            if ($catalog->alias != '') {
                $this->db->order_by('order_number, id');
                $category = $this->db->get_where('tb_book_category', array('id' => $catalog->alias));
                if ($category->num_rows() > 0) {
                    $this->db->order_by('order_number, id', 'ASC');
                    $sub_category = $this->db->get_where('tb_book_category', array('parent_id' => $category->row()->node_id, 'library_id' => $category->row()->library_id, 'district_id' => $category->row()->district_id));

                    $n = 0;
                    foreach ($sub_category->result() as $row) {
                        $list = (object)array();

                        if ($row->sorting_by <> '') {
                            if ($row->sorting_by == 'order_number') {
                                $this->db->order_by('order_number', 'ASC');
                            } else if ($row->sorting_by == 'name') {
                                $this->db->order_by('title', 'ASC');
                            }
                        } else {
                            $this->db->order_by('id', 'ASC');
                        }

                        $this->db->where('status', 'show');
                        $this->db->select('id, title, cover, preview, description');
                        $books = $this->db->get_where('tb_book', array('category_id' => $row->id));
                        $arr_books = array();
                        foreach ($books->result() as $book) {
                            $book->preview = explode(',', $book->preview);
                            $arr_books[] = $book;
                        }

                        $list->type = 'book';
                        $list->title = $row->category_name;
                        $list->icon = '';
                        $list->category_id = $row->id;
                        $list->id = $catalog->id;
                        $list->background_color = $n % 2 == 0 ? '#FFEFD5' : '#FFEBCD';
                        $list->slot = 0;
                        $list->objects = $arr_books;
                        $list->property = json_decode('{"slot" : 0, "title_color" : [{"start":0,"length":19,"color":"#6D6E70"}],"background_color" : ["#9EC5BC","#CFE1D8", "#EB7E5C"]}');


                        $arr_data[] = $list;
                        $n++;

                        if ($library_id == 29) {
                            if ((($version == '4.0.3' or $version == '4.0.4' or $version == '4.0.5' or $version == '4.0.6' or $version == "4.1.7" or $version == '4.1.10' or $version == '4.1.11' or $version == '4.2.0' or $version == '4.2.1') and $platform == 'iOS') or (($version == '1.2.19' or $version == '1.2.20' or $version == '4.1.8' or $version == '4.1.9') and $platform == 'android')) {
                                $list = (object)array();
                                $list->type = 'bar';
                                $list->background_color = '#EB7E5C';
                                $list->image = 'https://siamu.wisimo.com/file/siamu/theme/3/shelf05.png';
                                $arr_data[] = $list;
                            }
                        }

                    }
                }

            } else {

                $this->db->order_by('order_number', 'ASC');
                $catalog_lists = $this->db->get_where('tb_catalog_items', array('catalog_id' => $catalog_id));

                $arr_data = array();
                foreach ($catalog_lists->result() as $catalog_list) {

                    $list = $this->db->get_where('tb_tab_objects', array('id' => $catalog_list->list_id));

                    if ($list->num_rows() > 0) {
                        $list = $list->row();

                        if ($list->type == 'slide') {
                            $list->property = json_decode($list->property);
                            $list->objects = json_decode($list->data);
                            unset($list->data);

                            $this_group_viewer = json_decode($catalog_list->group_viewer);
                            if (count($this_group_viewer) > 0) {
                                if (!array_intersect($user_group, $this_group_viewer)) {
                                    continue;
                                }
                            }

                            $arr_data[] = $list;

                        } else if ($list->type == 'book') {

                            if ($list->category_id <> '') {
                                $category = $this->db->get_where('tb_book_category', array('id' => $list->category_id));

                                if ($category->sorting_by <> '') {
                                    if ($category->sorting_by == 'order_number') {
                                        $this->db->order_by('order_number', 'ASC');
                                    }
                                } else {
                                    $this->db->order_by('id', 'ASC');
                                }

                                $this->db->where('status', 'show');
                                $this->db->select('id, title, cover, preview, description');
                                $books = $this->db->get_where('tb_book', array('category_id' => $list->category_id));
                                $arr_books = array();
                                foreach ($books->result() as $book) {
                                    $book->preview = explode(',', $book->preview);
                                    $arr_books[] = $book;
                                }

                                $list->objects = $arr_books;

                            } else {

                                $this->db->where_in('id', json_decode($list->data));

                                $this->db->order_by('id', 'ASC');
                                $this->db->where('status', 'show');
                                $this->db->select('id, title, cover, preview, description');
                                $books = $this->db->get('tb_book');
                                $arr_books = array();
                                foreach ($books->result() as $book) {
                                    $book->preview = explode(',', $book->preview);
                                    $arr_books[] = $book;
                                }

                                $list->objects = $arr_books;
                                unset($list->data);

                            }

                            $list->property = json_decode($list->property);
                            $arr_data[] = $list;

                        } else if ($list->type == 'highlight') {

                            $list->objects = json_decode($list->data);

                            //if((strpos($user_agent, 'okhttp') !== FALSE))
                            //{
                            //    $list->objects = (object) array('title' => $list->objects[0]->title, 'cover' => $list->objects[0]->cover, 'id' => $list->objects[0]->id, 'description' => $list->objects[0]->description);
                            //}

                            unset($list->data);

                            $list->property = json_decode($list->property);

                            $arr_data[] = $list;

                        }
                    }

                    if ($library_id == 29) {
                        if ((($version == '4.0.3' or $version == '4.0.4' or $version == '4.0.5' or $version == "4.0.6" or $version == "4.1.7" or $version == '4.1.10' or $version == '4.1.11' or $version == '4.2.0' or $version == '4.2.1') and $platform == 'iOS') or (($version == '1.2.19' or $version == '1.2.20' or $version == '4.1.8' or $version == '4.1.9') and $platform == 'android')) {
                            $list = (object)array();
                            $list->type = 'bar';
                            $list->background_color = '#FF8863';
                            $list->image = 'https://siamu.wisimo.com/file/siamu/theme/3/shelf03.png';
                            $arr_data[] = $list;
                        }
                    }
                }
            }


            $result = array('status' => 200, 'message' => 'Done', 'entries' => $arr_data, 'catalog' => array('title' => $catalog->name, 'description' => $catalog->description, 'background_color' => '#9EC5BC'));

        } else {
            $result = array('status' => 404, 'message' => 'Unknown Action');
        }

        echo json_encode($result);
        exit();
    }

    function book_list()
    {
        if ($this->input->post()) {
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $category_id = $this->input->post('category_id');
            $library_id = $this->input->post('library_id');
            $page = $this->input->post('page');

            $user_group = array();
            if ($page == '') {
                $page = 1;
            }
            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);
                $user_group = explode(',', $user->group_viewer);
            } else {
                $user = '';
            }

            if ($category_id <> '') {
                $this->db->where('id', $category_id);
                $category = $this->db->get('tb_book_category')->row();

                if ($category->catalog_id <> '') {
                    $this->show_catalog($category->catalog_id);
                }

                $parent_id = $category->node_id;
            } else {
                $parent_id = 1;
            }

            $sub_category = $this->book_subcategory($parent_id, array('library_id' => $library_id, 'user_id' => $user_id, 'session' => $session));

            $this->find_category_id($sub_category);

            if (!in_array($category->id, $this->cat_ids)) {
                array_push($this->cat_ids, $category->id);
            }

            if ($user->group_member == 3 || $user->group_member == 2) {
                if ($user->group_member == 2) {
                    $groups_moderator = $this->db->get_where('tb_category_moderator_viewer', array('group_mod_id' => $user->group_moderator, 'library_id' => $user->library));
                    foreach ($groups_moderator->result() as $group_moderator) {
                        if (!in_array($group_moderator->category_id, $this->cat_ids)) {
                            array_push($this->cat_ids, $group_moderator->category_id);
                        }
                    }
                }

                $this->db->where('status !=', 'hide');

            } else {

                $this->db->where('status', 'show');
            }

            if ($library_id == 35) {
                $this->db->order_by('order_number', 'ASC');
            }
            $this->db->where_in('category_id', $this->cat_ids);
            //$this->db->limit(10, $page * 10 - 10);
            $this->db->order_by('id', 'DESC');
            $this->db->select('id, category_id, library_id, title, cover, description, preview');
            $books = $this->db->get('tb_book');

            $data = array();
            if ($books->num_rows() > 0) {
                foreach ($books->result() as $book) {

                    if ($user->group_member != 3) {
                        $this->db->where('ebook_id', $book->id);
                        $check_group_viewer = $this->db->get('tb_book_group_viewer');

                        $group_viewer = array();

                        if ($check_group_viewer->num_rows() > 0) {
                            foreach ($check_group_viewer->result() as $group) {
                                array_push($group_viewer, $group->group_viewer_id);
                            }

                            if (array_intersect($group_viewer, $user_group)) {

                            } else {
                                continue;
                            }
                        }
                    }

                    $book->preview = explode(',', $book->preview);
                    $data[] = $book;
                }

                $result = array('status' => 200, 'message' => 'Done', 'entries' => $data, 'cats' => $this->cat_ids);
            } else {
                $result = array('status' => 200, 'message' => 'Done', 'entries' => array());
            }
        } else {
            $result = array('status' => 500, 'message' => 'Unknown Action');
        }

        echo json_encode($result);

    }

    private function find_category_id($subcategory)
    {
        foreach ($subcategory as $sub) {
            if (!in_array($sub->id, $this->cat_ids)) {
                array_push($this->cat_ids, $sub->id);
            }

            if (!empty($sub->subcategory)) {
                $this->find_category_id($sub->subcategory);
            }
        }
    }

    function book_category($parent_id = 0)
    {
        $catss = array();
        if ($this->input->post()) {
            $parent_id = $parent_id == null ? $this->input->post('parent_id') : $parent_id;
            $category_id = $this->input->post('category_id');
            $test = $this->input->post('test');
            $library_id = $this->input->post('library_id');
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $platform = $this->input->post('platform');

            $data['parent_id'] = $parent_id;
            $data['library_id'] = $library_id;
            $data['user_id'] = $user_id;
            $data['session'] = $session;
            $data['platform'] = $platform;

            if ($parent_id == '') {
                $parent_id = 1;
            }

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);
            }

            $this->db->where('library_id', $library_id);
            if ($user_id <> '') {
                $this->db->where('district_id', $user->district_id);
            }
            $this->db->order_by('order_number,id');
            $this->db->where('parent_id', $parent_id);
            $this->db->select('id, node_id, parent_id, category_name, cover, catalog_id, group_viewer, visible');
            $categories = $this->db->get('tb_book_category');


            // Find current Category as parent
            if ($user_id <> '') {
                $this->db->where('district_id', $user->district_id);
            }
            $this->db->order_by('order_number,id');
            $this->db->select('id, node_id, parent_id, category_name, cover, catalog_id, group_viewer, visible');
            $my_cat = $this->db->get_where('tb_book_category', array('node_id' => $parent_id, 'library_id' => $library_id));
            if ($my_cat->num_rows() > 0) {
                if ($my_cat->row()->node != 1 and $my_cat->row()->parent_id != 0) {
                    $my_cat = $my_cat->row();
                    if ($my_cat->catalog_id <> '') {
                        if ($platform == 'web') {
                            $my_cat->subcategory = $this->book_subcategory($my_cat->node_id, $data) == null ? array() : $this->book_subcategory($my_cat->node_id, $data);

                        } else {
                            $my_cat->subcategory = array();
                        }
                    } else {
                        $my_cat->subcategory = $this->book_subcategory($my_cat->node_id, $data) == null ? array() : $this->book_subcategory($my_cat->node_id, $data);

                    }

                    if ($platform == 'web') {
                        foreach ($my_cat->subcategory as $subcat) {
                            $this->concat_subcat_id($subcat);
                        }

                        $my_cat->sub_ids = $this->sub_cats;
                        $this->sub_cats = '';

                        $catss[$my_cat->id] = $my_cat->sub_ids;

                    }


                    $cats[] = $my_cat;
                }
            }


            if ($categories->num_rows() > 0) {
                foreach ($categories->result() as $category) {

                    if ($category->visible == 'hidden') {
                        continue;
                    }

                    if ($user->group_member == 3) {


                        if ($category->catalog_id <> '') {
                            if ($platform == 'web') {
                                $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);

                            } else {
                                $category->subcategory = array();
                            }
                        } else {
                            $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);
                        }

                        if ($platform == 'web') {
                            foreach ($category->subcategory as $subcat) {
                                $this->concat_subcat_id($subcat);
                            }

                            $category->sub_ids = $this->sub_cats;
                            $this->sub_cats = '';

                            $catss[$category->id] = $category->sub_ids;

                        }

                        $category->catalog_id = ($category->catalog_id == '' ? '' : $category->catalog_id);
                        $category->cover = ($category->cover == '' ? 'https://www.wisimo.com/assets/img/folder.png' : $category->cover);

                        unset($category->group_viewer);
                        $cats[] = $category;
                    } else {
                        $current_category_viewer = json_decode($category->group_viewer);

                        if (!empty($current_category_viewer)) {
                            if (array_intersect($current_category_viewer, explode(',', $user->group_category))) {
                                if ($category->catalog_id <> '') {
                                    if ($platform == 'web') {
                                        $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);

                                    } else {
                                        $category->subcategory = array();
                                    }
                                } else {
                                    $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);
                                }

                                if ($platform == 'web') {
                                    foreach ($category->subcategory as $subcat) {
                                        $this->concat_subcat_id($subcat);
                                    }

                                    $category->sub_ids = $this->sub_cats;
                                    $this->sub_cats = '';
                                    $catss[$category->id] = $category->sub_ids;
                                }


                                $category->catalog_id = ($category->catalog_id == '' ? '' : $category->catalog_id);
                                $category->cover = ($category->cover == '' ? 'https://www.wisimo.com/assets/img/folder.png' : $category->cover);
                                unset($category->group_viewer);
                                $cats[] = $category;
                            }
                        } else {

                            if ($category->catalog_id <> '') {
                                if ($platform == 'web') {
                                    $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);

                                } else {
                                    $category->subcategory = array();
                                }
                            } else {
                                $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);
                            }

                            if ($platform == 'web') {
                                foreach ($category->subcategory as $subcat) {
                                    $this->concat_subcat_id($subcat);
                                }

                                $category->sub_ids = $this->sub_cats;
                                $this->sub_cats = '';
                                $catss[$category->id] = $category->sub_ids;
                            }

                            $category->catalog_id = ($category->catalog_id == '' ? '' : $category->catalog_id);
                            $category->cover = ($category->cover == '' ? 'https://www.wisimo.com/assets/img/folder.png' : $category->cover);
                            unset($category->group_viewer);
                            $cats[] = $category;
                        }

                    }
                }
            }

            if ($category_id <> '') {
                foreach ($cats as $cat) {
                    if ($cat->id == $category_id) {
                        $cats = $cat->subcategory;
                    }
                }
            }

            if ($cats == null) {
                $result = array('status' => 404, 'message' => 'No more');
            } else {
                if ($category_id <> '' and $test == 1) {
                    $current_category = $this->db->get_where('tb_book_category', array('id' => $category_id))->row();
                    $current_category->subcategory = $cats;
                    $cats = array($current_category);
                }
                $result = array('status' => 200, 'message' => 'Done', 'entries' => $cats, 'categories' => $catss);
            }


        } else {
            $result = array('status' => 500, 'message' => 'Unknown Action');
        }

        echo json_encode($result);
    }

    private function concat_subcat_id($sub)
    {
        if ($this->sub_cats == '') {
            $this->sub_cats = $sub->id;
        } else {
            $this->sub_cats .= ',' . $sub->id;
        }

        foreach ($sub->subcategory as $s) {
            $this->concat_subcat_id($s);
        }
    }

    private function book_subcategory($parent_id = null, $data)
    {
        $library_id = $data['library_id'];
        $user_id = $data['user_id'];
        $session = $data['session'];
        $platform = $data['platform'];

        if ($parent_id == '') {
            $parent_id = 1;
        }

        if ($user_id <> '') {
            $this->checkSession($session, $user_id);
            $user = $this->v10_model->getUserByID($user_id);
        }

        $this->db->where('library_id', $library_id);
        if ($user_id <> '') {
            $this->db->where('district_id', $user->district_id);
        }

        $this->db->order_by('order_number, id');
        $this->db->where('parent_id', $parent_id);
        $this->db->select('id, node_id, parent_id, category_name, cover, catalog_id, group_viewer');
        $categories = $this->db->get('tb_book_category');

        if ($categories->num_rows() > 0) {
            if ($user->group_member == 2) {
                /*check moderator group viewer*/
                $group_moderator = @explode(",", $user->group_moderator);

                $this->db->where_in('group_mod_id', $group_moderator);

                $query = $this->db->get_where("tb_category_moderator_viewer",
                    array(
                        "library_id" => $library_id,
                        "district_id" => $user->district_id
                    ));

                if ($query->num_rows() > 0) {

                    $mod_cat = array();

                    foreach ($query->result() as $r) {
                        array_push($mod_cat, $r->category_id);
                    }
                }
            }

            foreach ($categories->result() as $category) {

                if ($category->visible == 'hidden') {
                    continue;
                }

                if ($user->group_member == 3) {

                    if ($category->catalog_id <> '') {
                        if ($platform == 'web') {
                            $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);

                        } else {
                            $category->subcategory = array();
                        }
                    } else {
                        $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);
                    }

                    if ($platform == 'web') {
                        foreach ($category->subcategory as $subcat) {
                            $this->concat_subcat_id($subcat);
                        }

                        $category->sub_ids = $this->sub_cats;
                        $this->sub_cats = '';
                    }


                    $category->catalog_id = ($category->catalog_id == '' ? '' : $category->catalog_id);
                    $category->cover = ($category->cover == '' ? 'https://www.wisimo.com/assets/img/folder.png' : $category->cover);
                    $cats[] = $category;

                } else {

                    $current_category_viewer = json_decode($category->group_viewer);

                    if (!empty($current_category_viewer)) {
                        if (array_intersect($current_category_viewer, explode(',', $user->group_category))) {
                            if ($category->catalog_id <> '') {
                                if ($platform == 'web') {
                                    $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);

                                } else {
                                    $category->subcategory = array();
                                }
                            } else {
                                $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);
                            }

                            if ($platform == 'web') {
                                foreach ($category->subcategory as $subcat) {
                                    $this->concat_subcat_id($subcat);
                                }

                                $category->sub_ids = $this->sub_cats;
                                $this->sub_cats = '';
                            }

                            $category->catalog_id = ($category->catalog_id == '' ? '' : $category->catalog_id);
                            $category->cover = ($category->cover == '' ? 'https://www.wisimo.com/assets/img/folder.png' : $category->cover);
                            unset($category->group_viewer);
                            $cats[] = $category;
                        }

                    } else {

                        if ($category->catalog_id <> '') {
                            if ($platform == 'web') {

                                $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);

                            } else {
                                $category->subcategory = array();
                            }
                        } else {
                            $category->subcategory = $this->book_subcategory($category->node_id, $data) == null ? array() : $this->book_subcategory($category->node_id, $data);
                        }

                        if ($platform == 'web') {
                            foreach ($category->subcategory as $subcat) {
                                $this->concat_subcat_id($subcat);
                            }

                            $category->sub_ids = $this->sub_cats;
                            $this->sub_cats = '';
                        }

                        $category->catalog_id = ($category->catalog_id == '' ? '' : $category->catalog_id);
                        $category->cover = ($category->cover == '' ? 'https://www.wisimo.com/assets/img/folder.png' : $category->cover);
                        unset($category->group_viewer);
                        $cats[] = $category;
                    }

                }
            }
        }

        return $cats;
    }

    private function check_category_is_public($library_id, $district_id, $category_id)
    {
        $q = $this->db->get_where("tb_book_category_viewer",
            array(
                "library_id" => $library_id,
                "district_id" => $district_id,
                "category_id" => $category_id
            ));

        if ($q->num_rows() < 1) {
            return true;
        }
        return false;
    }

    private function check_group_category($library_id, $district_id = 0, $group_category, $category_id)
    {
        if ($district_id == '') {
            $district_id = 0;
        }
        if ($group_category == '') {
            $query = $this->db->get_where("tb_book_category_viewer",
                array(
                    "library_id" => $library_id,
                    "district_id" => $district_id,
                    "category_id" => $category_id
                ));
            if ($query->num_rows() > 0) {

                return false;
            }
            return true;

        } else {
            $group_category = @explode(",", $group_category);
        }

        if (!empty($group_category)) {

            foreach ($group_category as $r) {

                $query = $this->db->get_where("tb_book_category_viewer",
                    array(
                        "library_id" => $library_id,
                        "district_id" => $district_id,
                        "category_viewer_id" => $r,
                        "category_id" => $category_id
                    ));
                if ($query->num_rows() > 0) {

                    return false;
                }
            }
            return true;
        }
        return true;
    }

    private function checkSession($session, $user_id)
    {
        if ($session == '') {
            $result = array('status' => 417, 'message' => 'Session required.');

            echo json_encode($result);
            exit();
        } else {

            // Check Session
            $check_session = $this->v10_model->checkSession($session, $user_id);
            if ($check_session == 404) {
                $result = array('status' => 403, 'message' => 'Your account has been logged in from another device.');

                echo json_encode($result);
                exit();
            } else if ($check_session == 500) {
                $result = array('status' => 403, 'message' => 'Your session has expired. Please log in again.');

                echo json_encode($result);
                exit();
            }
        }
    }

    // Course

    function course()
    {
        if ($this->input->post()) {
            $this->load->library('RNCryptor');

            $library_id = $this->input->post('library_id');
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);
            }

            $this->db->join('tb_course', 'tb_course.course_id = tb_user_course.course_id');

            $this->db->join('tb_course_library', 'tb_course_library.id = tb_user_course.course_library_id');

            $this->db->join('tb_course_level', 'tb_course.course_level_id = tb_course_level.id');

            $this->db->join('tb_course_category', 'tb_course.course_category_id = tb_course_category.id');

            $this->db->where('tb_user_course.library_id', $library_id);

            $this->db->where('tb_user_course.user_id', $user_id);

            $this->db->where('tb_user_course.district_id', $user->district_id);

            $this->db->select('course_name_th, course_name_en, tb_course.course_id, course_library_id, course_instructor, course_type, course_description, course_img_preview, course_vdo_preview');

            $query = $this->db->get('tb_user_course');

            if ($query->num_rows() > 0) {

                $courses = $query->result();

                foreach ($query->result() as $row) {
                    $row->course_vdo_preview = Security::encrypt($row->course_vdo_preview, ENCRYPTION_KEY);
                    $data[] = $row;
                }

            } else {
                $courses = false;
            }

            if ($courses) {
                $result = array('status' => 200, 'message' => 'Done', 'entries' => $courses);
            } else {
                $result = array('status' => 404, 'message' => 'No Course');
            }
        } else {
            $result = array('status' => 400, 'message' => 'Bad Request');
        }
        echo json_encode($result);
    }

    function course_contents()
    {
        if ($this->input->post()) {
            $library_id = $this->input->post('library_id');
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $course_id = $this->input->post('course_id');

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);
            }

            $this->db->order_by('sort', 'ASC');
            $this->db->where('course_id', $course_id);
            $course = $this->db->get('tb_content');

            foreach ($course->result() as $c) {
                if ($user_id <> '' and $c->type == 'exams') {
                    $this->db->order_by('percent', 'DESC');
                    $this->db->limit(1);
                    $this->db->where('content_id', $c->id);
                    $this->db->where('user_id', $user_id);
                    $res = $this->db->get('tb_exams_summary');

                    if ($res->num_rows() > 0) {
                        $c->score = $res->row()->score;
                        $c->total = $res->row()->total;
                        $c->percent = $res->row()->percent;
                    }
                }

                $data[] = $c;
            }

            $result = array('status' => 200, 'message' => 'Done', 'entries' => $data, '');

        } else {
            $result = array('status' => 400, 'message' => 'Bad Request');
        }
        echo json_encode($result);
    }

    function content()
    {
        if ($this->input->post()) {
            $library_id = $this->input->post('library_id');
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $content_id = $this->input->post('content_id');

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);
            }

            $this->db->where('content_id', $content_id);
            $content = $this->db->get('tb_resource');

            if ($content->num_rows() > 0) {
                $result = array('status' => 200, 'message' => 'Done', 'entries' => $content->row());
            } else {
                $result = array('status' => 404, 'message' => 'No Content');
            }
        } else {
            $result = array('status' => 400, 'message' => 'Bad Request');
        }
        echo json_encode($result);
    }

    // Exam

    function exam()
    {
        if ($this->input->post()) {
            $library_id = $this->input->post('library_id');
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $exam_id = $this->input->post('exam_id');

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);
            }

            $this->db->where('exams_main_id', $exam_id);
            $this->db->select('id, exams_main_id, title, exams_img, exams_group_id');
            $exam = $this->db->get('tb_exams');

            if ($exam->num_rows() > 0) {
                foreach ($exam->result() as $question) {
                    $this->db->order_by('sort', 'ASC');
                    $this->db->where('exams_id', $question->id);
                    $choices = $this->db->get('tb_exams_choice');

                    $question->choices = $choices->result();
                    $data[] = $question;
                }
                $result = array('status' => 200, 'message' => 'Done', 'entries' => $data);
            } else {
                $result = array('status' => 404, 'message' => 'No Content');
            }
        } else {
            $result = array('status' => 400, 'message' => 'Bad Request');
        }

        echo json_encode($result);
        exit();
    }

    function answer()
    {
        if ($this->input->post()) {
            $this->load->model('lms_model');

            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $choice = $this->input->post('choices');
            $exams = $this->input->post('exams');
            $course_id = $this->input->post('course_id');
            $content_id = $this->input->post('content_id');
            $exams_main_id = $this->input->post('exams_main_id');
            $course_library_id = $this->input->post('library_id');
            $exams_start_datetime = date('Y-m-d H:i:s', $this->input->post('exams_start_datetime'));

            $this->checkSession($session, $user_id);
            $user = $this->v10_model->getUserByID($user_id);

            $score = 0;
            $total = count($exams);

            if (count($choice) > 0) {
                $this->lms_model->deleteAnswer($course_library_id, $user_id, $content_id, $exams_main_id);

                for ($i = 0; $i < count($choice); $i++) {

                    $this->lms_model->examsAnswer($course_library_id, $content_id, $exams_main_id, $exams[$i], $choice[$i], $user_id);

                    if ($choice[$i] == $this->lms_model->findChoiceCorrect($exams[$i])) {

                        $score += 1;
                    }
                }

                $this->lms_model->score($course_library_id, $course_id, $content_id, $exams_main_id, $total, $score, $user_id, $exams_start_datetime);

                $this->lms_model->learn($course_library_id, $course_id, $content_id, 'end_exams');

                $this->lms_model->findExamsSortPosition($course_library_id, $course_id, $content_id, $user_id);

                $result = array('status' => 200, 'message' => 'Done', 'entries' => array('score' => $score, 'total' => $total));

            } else {
                $result = array('status' => 411, 'message' => 'Choice can\'t be empty.');
            }
        } else {
            $result = array('status' => 400, 'message' => 'Bad Request');
        }

        echo json_encode($result);
        exit();
    }

    function broadcast_template()
    {
        if ($this->input->post()) {
            $course_library = $this->db->get_where('tb_course_library', array('id' => $this->input->post('clb_id')))->row();
            $q = $this->db->get_where('tb_broadcast_template', array('id' => $this->input->post('template_id')));
            $q = $q->row();

            $dStart = strtotime($course_library->course_start_date);
            $dEnd = strtotime($course_library->course_end_date);
            $dDiff = $dEnd - $dStart;
            $days = (($dDiff / 60) / 60) / 24 + 1;


            if ($q->purpose == 'remind') {
                $estimated_date = date('d/m/Y', strtotime('+' . (int)(($days * 25) / 100) . ' days', strtotime($course_library->course_start_date)));
            } else if ($q->purpose == 'alert') {
                $estimated_date = date('d/m/Y', strtotime('+' . (int)(($days * 75) / 100) . ' days', strtotime($course_library->course_start_date)));

            } else if ($q->purpose == 'workshop') {
                $estimated_date = date('d/m/Y', strtotime('-7 days', strtotime($course_library->course_workshop_date)));
            } else {
                $estimated_date = '';
            }

            $q->estimated_date = $estimated_date;

            echo json_encode(array('status' => 200, 'message' => 'Done', 'entries' => $q));
        }
    }

    function home()
    {
        if ($this->input->post()) {
            $user_agent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';

            $module = $this->input->post('module');
            $library_id = $this->input->post('library_id');
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $version = $this->input->post('version');

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);
            }

            $objects = $this->db->get_where('tb_tab_objects', array('library_id' => $library_id, 'status' => 'available'));

            foreach ($objects->result() as $object) {
                if ($object->type == 'slide') {
                    $object->property = json_decode($object->property);
                    $object->objects = json_decode($object->data);
                    unset($object->data);
                } else if ($object->type == 'book') {
                    if ($object->category_id <> '') {

                        $this->db->order_by('id', 'DESC');
                        $this->db->where('status', 'show');
                        $this->db->select('id, title, cover, preview, description');
                        $books = $this->db->get_where('tb_book', array('category_id' => $object->category_id));
                        foreach ($books->result() as $book) {
                            $book->preview = explode(',', $book->preview);
                            $arr_books[] = $book;
                        }
                        $object->property = json_decode($object->property);
                        $object->objects = $arr_books;

                    } else {

                        $this->db->where_in('id', json_decode($object->data));

                        $this->db->order_by('id', 'DESC');
                        $this->db->where('status', 'show');
                        $this->db->select('id, title, cover, preview, description');
                        $books = $this->db->get('tb_book');
                        foreach ($books->result() as $book) {
                            $book->preview = explode(',', $book->preview);
                            $arr_books[] = $book;
                        }
                        $object->property = json_decode($object->property);
                        $object->objects = $arr_books;
                        unset($object->data);

                    }
                } else if ($object->type == 'highlight') {
                    if ($library_id == 31) {
                        $arr_v = array('4.0.3', '4.0.4', '4.0.5', '4.0.6', '4.1.8', '4.1.9', '1.2.20');
                        if (in_array($version, $arr_v)) {
                            $object->objects = array(json_decode($object->data));
                        } else {
                            $object->objects = json_decode($object->data);
                        }
                    } else {
                        $object->objects = json_decode($object->data);
                    }
                    $object->title_color = json_decode($object->title_color);
                    $object->property = json_decode($object->property);

                    unset($object->data);
                }
                $tab_data[] = $object;
            }

            $result = array('user_agent' => $user_agent, 'status' => 200, 'message' => 'Done', 'entries' => $tab_data);

        } else {
            $result = array('status' => 500, 'message' => 'Action Unknown');
        }

        echo json_encode($result);
    }


    function slideshow()
    {
        if ($this->input->post()) {
            $slide_show_id = $this->input->post('slide_show_id');
            $slides = $this->db->get_where('tb_home', array('id' => $slide_show_id));

            if ($slides->num_rows() > 0) {
                $slide = $slides->row();

                if ($slide->home_img1 <> '') {
                    $data[] = array(
                        'image_url' => base_url() . $slide->home_img1,
                        'text' => $slide->home_text1,
                        'link' => $slide->home_link1
                    );
                }
                if ($slide->home_img2 <> '') {
                    $data[] = array(
                        'image_url' => base_url() . $slide->home_img2,
                        'text' => $slide->home_text2,
                        'link' => $slide->home_link2
                    );
                }
                if ($slide->home_img3 <> '') {
                    $data[] = array(
                        'image_url' => base_url() . $slide->home_img3,
                        'text' => $slide->home_text3,
                        'link' => $slide->home_link3
                    );
                }
                if ($slide->home_img4 <> '') {
                    $data[] = array(
                        'image_url' => base_url() . $slide->home_img4,
                        'text' => $slide->home_text4,
                        'link' => $slide->home_link4
                    );
                }
                if ($slide->home_img5 <> '') {
                    $data[] = array(
                        'image_url' => base_url() . $slide->home_img5,
                        'text' => $slide->home_text5,
                        'link' => $slide->home_link5
                    );
                }
                if ($slide->home_img6 <> '') {
                    $data[] = array(
                        'image_url' => base_url() . $slide->home_img6,
                        'text' => $slide->home_text6,
                        'link' => $slide->home_link6
                    );
                }
                if ($slide->home_img7 <> '') {
                    $data[] = array(
                        'image_url' => base_url() . $slide->home_img7,
                        'text' => $slide->home_text7,
                        'link' => $slide->home_link7
                    );
                }

                $result = array('status' => 200, 'message' => 'Done', 'entries' => $data);

            } else {
                $result = array('status' => 404, 'message' => 'No slide');
            }
        } else {
            $result = array('status' => 500, 'message' => 'Action Unknown');
        }

        echo json_encode($result);
    }

    function theme()
    {
        if ($this->input->post()) {
            $library_id = $this->input->post('library_id');
            $platform = $this->input->post('platform');
            $version = $this->input->post('version');
            $library = $this->db->get_where('tb_library', array('id' => $library_id))->row();
            $library_theme = $this->db->get_where('tb_theme', array('library_id' => $library_id, 'status' => 'active'))->row();
            $this->db->select('type, key_name, values');
            $theme = $this->db->get_where('tb_theme_data', array('theme_id' => $library_theme->id));

            if ($theme->num_rows() > 0) {
                $data = $theme->result();
                //strtotime($library_theme->last_modified_date)


                $this->load->library('user_agent');

                $ios = '';
                $android = '';


                $result = array('status' => 200, 'message' => 'Done', 'entries' => array('update_require' => array('ios' => $ios, 'android' => $android, 'message' => 'Your current app version needs to be update.'), 'revision' => strtotime($library_theme->last_modified_date), 'root_link' => base_url() . $library->library_path . '/theme/' . $library_theme->id . '/', 'data' => $data));

            } else {
                $result = array('status' => 404, 'message' => 'No Theme');
            }

        } else {
            $result = array('status' => 400, 'message' => 'Bad Request');
        }

        echo json_encode($result);
    }

    function search_book()
    {
        $keyword = $this->input->post('keyword');
        $library_id = $this->input->post('library_id');
        $user_id = $this->input->post('user_id');
        $session = $this->input->post('session');

        $platform = $this->input->post('platform');
        $version = $this->input->post('version');

        if ($user_id <> '') {
            $this->checkSession($session, $user_id);
            $user = $this->v10_model->getUserByID($user_id);
        }

        $this->db->where('library_id', $library_id);
        $this->db->like('title', $keyword, 'both');
        $this->db->or_like('tags', $keyword, 'both');
        $this->db->order_by('id', 'DESC');
        $this->db->select('id, category_id, library_id, title, cover, description, preview');
        $this->db->where('status', 'show');
        $books = $this->db->get('tb_book');

        $sub_cat = array('library_id' => $library_id, 'user_id' => $user_id, 'session' => $session);

        if (($platform == 'iOS' and ($version == '4.1.7' or $version == '4.1.10' or $version == '4.1.11' or $version == '4.2.0' or $version == '4.2.1' or $version == '1.0')) or ($platform == 'android' and ($version == '1.2.20' or $version == '4.1.8' or $version == '4.1.9'))) {
            if ($version == '1.0') {
                $library_id = 1;
            }

            $book = array();
            if ($books->num_rows() > 0) {
                foreach ($books->result() as $b) {
                    $book[] = $b;
                }
            }


            $this->db->where('library_id', $library_id);
            $this->db->order_by('id', 'DESC');
            $this->db->like('category_name', $keyword, 'both');
            $this->db->select('id, node_id, parent_id, category_name, cover, catalog_id');
            $category = $this->db->get('tb_book_category');

            $categories = array();
            if ($category->num_rows() > 0) {
                foreach ($category->result() as $cat) {
                    if ($cat->cover == '') {
                        $cat->cover = 'https://www.wisimo.com/assets/img/folder.png';
                    }

                    if ($cat->catalog_id == '') {
                        $cat->catalog_id = '';
                    }

                    $cat->subcategory = $this->book_subcategory($cat->node_id, $sub_cat) == null ? array() : $this->book_subcategory($cat->node_id, $sub_cat);

                    $categories[] = $cat;
                }
            }

            if (($platform == 'android' and ($version == '4.1.8' or $version == '4.1.9')) or ($platform == 'iOS' and ($version == '4.1.7' or $version == '4.1.10' or $version == '4.1.11' or $version == '4.2.0' or $version == '4.2.1' or $version == '1.0'))) {
                $result = array('status' => 200, 'message' => 'Done', 'entries' => array('book' => $book, 'category' => $categories));
            } else {
                $result = array('status' => 200, 'message' => 'Done', 'entries' => array('book' => $book, 'category' => array()));
            }

        } else {
            $result = array('status' => 200, 'message' => 'Done', 'entries' => $books->result());
        }


        echo json_encode($result);
    }

    function upload_theme()
    {
        header('Content-Type: text/html');

        error_reporting(-1);

        for ($i = 0; $i < count($_FILES["file"]["name"]); $i++) {
            if (copy($_FILES["file"]["tmp_name"][$i], $_SERVER["DOCUMENT_ROOT"] . '/file/siamu/' . $_FILES["file"]["name"][$i])) {
            } else {
                echo $_FILES["file"]["errors"][$i];
            }
        }

        redirect('v10/upload_form', 'refresh');
    }

    function upload_form()
    {
        header('Content-Type: text/html');

        ?>
        <html>
        <body>
        <form enctype="multipart/form-data" action="<?= base_url() ?>v10/upload_theme/" method="post">
            <input type="file" name="file[]" multiple>
            <button type="submit">Submit</button>
        </form>
        </body>
        </html>
        <?php
    }

    function save_log()
    {
        if ($this->input->post()) {
            $this->load->library('user_agent');

            $library_id = $this->input->post('library_id');
            $district_id = $this->input->post('district_id');
            $user_id = $this->input->post('user_id');
            $book_id = $this->input->post('book_id');
            $canvas_id = $this->input->post('canvas_id');
            $object_id = $this->input->post('object_id');
            $platform = $this->input->post('platform');
            $type = $this->input->post('type');
            if (strpos($this->input->post('datetime'), '/') or strpos($this->input->post('datetime'), '-')) {
                $datetime = ($this->input->post('datetime') == '' ? date('Y-m-d H:i:s') : $this->input->post('datetime'));
            } else {
                $datetime = date('Y-m-d H:i:s', $this->input->post('datetime'));

            }

            $data = array(
                'library_id' => $library_id,
                'district_id' => $district_id,
                'user_id' => $user_id,
                'book_id' => $book_id,
                'canvas_id' => $canvas_id,
                'object_id' => $object_id,
                'datetime' => $datetime,
                'platform' => $platform,
                'type' => $type,
                'agent' => $this->agent->agent_string()
            );

            $this->db->insert('tb_reader_log', $data);

            $result = array('status' => 200, 'message' => 'Done');

            echo json_encode($result);

        }
    }

    private function show_catalog($id, $data)
    {

        if ($data['user_id'] <> '') {
            $this->checkSession($data['session'], $data['user_id']);
        }

        $this->db->order_by('order_number', 'ASC');
        $catalog_items = $this->db->get_where('tb_catalog_items', array('catalog_id' => $id))->result();

        foreach ($catalog_items as $item) {
            $this->db->select('id, type, title, icon, data');
            $object = $this->db->get_where('tb_tab_objects', array('id' => $item->list_id))->row();

            if ($object->type == 'slide') {
                $object->objects = json_decode($object->data);
                unset($object->data);
            } else if ($object->type == 'book') {
                if ($object->category_id <> '') {

                    $this->db->order_by('id', 'DESC');
                    $this->db->where('status', 'show');
                    $this->db->select('id, title, cover, preview, description');
                    $books = $this->db->get_where('tb_book', array('category_id' => $object->category_id));
                    foreach ($books->result() as $book) {
                        $book->preview = explode(',', $book->preview);
                        $arr_books[] = $book;
                    }
                    $object->objects = $arr_books;
                    unset($object->data);

                } else {

                    $this->db->select('id, title, cover, preview, description');
                    $this->db->where_in('id', json_decode($object->data));
                    $books = $this->db->get('tb_book');
                    foreach ($books->result() as $book) {
                        $book->preview = explode(',', $book->preview);
                        $arr_books[] = $book;
                    }
                    $object->objects = $arr_books;
                    unset($object->data);

                }
            } else if ($object->type == 'highlight') {
                $object->objects = json_decode($object->data);
                unset($object->data);
            }
            $tab_data[] = $object;
        }

        $result = array('status' => 200, 'message' => 'Done', 'entries' => $tab_data);
        echo json_encode($result);
        exit();
    }

    function all_category()
    {
        $library_id = $this->input->post('library_id');
        $categories = $this->db->get_where('tb_book_category', array('library_id' => $library_id));

        $data = array();
        foreach ($categories->result() as $cat) {
            $data[(string)$cat->id] = $cat->category_name;
        }

        $result = array('status' => 200, 'message' => 'Done', 'entries' => $data);
        echo json_encode($result);

    }

    function subscribe()
    {
        if ($this->input->post()) {

            $library_id = $this->input->post('library_id');
            $user_id = $this->input->post('user_id');
            $session = $this->input->post('session');
            $code = $this->input->post('code');

            if ($code == '') {
                echo json_encode(array('status' => 500, 'message' => 'Subscription code is required.'));
                exit();
            }

            if ($user_id <> '') {
                $this->checkSession($session, $user_id);
                $user = $this->v10_model->getUserByID($user_id);

                $group_category = $this->db->get_where('tb_group_category_viewer', array('library_id' => $library_id, 'district_id' => $user->district_id, 'code' => $code));
                if ($group_category->num_rows() > 0) {

                    if ($group_category->row()->accept_by_admin == 'yes') {

                        $check_request = $this->db->get_where('tb_subscription', array('user_id' => $user_id, 'category_id' => $group_category->row()->category_id));
                        if ($check_request->num_rows() > 0) {
                            echo json_encode(array('status' => 500, 'message' => 'You have already requested.'));
                            exit();
                        } else {

                            $this->db->insert('tb_subscription', array('user_id' => $user_id, 'category_id' => $group_category->row()->category_id, 'library_id' => $library_id, 'district_id' => $user->district_id, 'status' => 'request'));
                            echo json_encode(array('status' => 200, 'message' => 'Your subscription request has been sent.'));
                            exit();
                        }

                    } else {

                        $user_group = explode(',', $user->group_category);

                        if (!in_array($group_category->row()->category_id, $user_group)) {
                            array_push($user_group, $group_category->row()->category_id);

                            $new_group = json_encode($user_group);
                            $new_group = str_replace("[", '', $new_group);
                            $new_group = str_replace("]", '', $new_group);
                            $new_group = str_replace('"', '', $new_group);

                            $this->db->where('id', $user_id);
                            $this->db->update('tb_user', array('group_category' => $new_group));


                            $this->db->where('id', $group_category->row()->id);
                            $this->db->update('tb_subscription', array('status' => 'accepted'));
                            echo json_encode(array('status' => 200, 'message' => 'Done'));
                            exit();

                        } else {

                            echo json_encode(array('status' => 500, 'message' => 'User has already been subscribed this category.'));
                            exit();

                        }

                    }

                } else {
                    echo json_encode(array('status' => 404, 'message' => $code . ' not found.'));
                    exit();
                }
            } else {
                echo json_encode(array('status' => 500, 'message' => 'Available Only for Member.'));
                exit();
            }
        } else {
            echo json_encode(array('status' => 500, 'message' => 'Unknown Action'));
            exit();
        }
    }

}
