<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class Auth
{
    private $ci;
    
    function __construct(){

        error_reporting(0);
        
        $this->ci=&get_instance();
        
        $this->ci->load->library('session');

        if($this->ci->session->userdata('login') === TRUE)
        {
            define('IS_ALIVE', TRUE);
			
            define('SESSION', $this->ci->session->userdata('session'));
			
            define('USER_ID', $this->ci->session->userdata('user_id'));

        }else{
            define('IS_ALIVE', FALSE);
        }
        
        if($this->ci->session->userdata('library_login') === TRUE)
        {
            define('LIBRARY_LOGIN', TRUE);
            
            define('USER_ID', $this->ci->session->userdata('user_id'));
            
        }else{
            
            define('LIBRARY_LOGIN', FALSE);
        }
        
        if(IS_ALIVE == FALSE && LIBRARY_LOGIN == FALSE){
            
            define('DISTRICT_ID' ,0);
        }
        
        define('LIBRARY', $this->get_library()["library_code"]);
	
        define('LIBRARY_ID', $this->get_library()["id"]);
        define('LIBRARY_NAME', $this->get_library()["library_name"]);
        

        if(IS_ALIVE == true || LIBRARY_LOGIN == true){
            if($this->ci->session->userdata('new_version') == true) {
                $this->get_user_permission2();
            } else {
                $this->get_user_permission();
            }
        }
        

/*ADD  2 LANGUAGES SYSTEM*/

        if($this->ci->session->userdata('lang') == 'th')

        {

            $this->ci->lang->load('thai', 'thai');

            define('LANGUAGE', 'TH');

        }else{

            $this->ci->lang->load('english', 'english');

            define('LANGUAGE', 'ENG');

        }

        if(!empty($this->ci->session->userdata('type_question'))) {
            $type_question = $this->ci->session->userdata('type_question');

            define('TYPE_QUESTION' , $type_question);

        } else {

            define('TYPE_QUESTION' , 1);
        }

        $this->logging();


    } // End construct

    function xss_clean($text = '', $is_content = false) {

        if($is_content == true)
        {
            $clean = $this->ci->security->xss_clean($text);
        }else{
            $clean = htmlspecialchars($this->ci->security->xss_clean($text),ENT_QUOTES, 'UTF-8');
        }

        return str_replace("[removed]", "", $clean);
    }
    
    function get_user_permission(){
        $this->ci->db->select('username, first_name, last_name, role, district_id, group_member, group_viewer, group_category, group_moderator, library');

        $q = $this->ci->db->get_where('tb_user',array('id' => USER_ID));

        if($q->num_rows() > 0) {

            define('ROLE_ID',$q->row()->role);
            define('GROUP_CATEGORY',$q->row()->group_category);

            if($q->row()->role == 1){
                if(!empty($this->ci->session->userdata('district_id')))
                {
                   define('DISTRICT_ID', $this->ci->session->userdata('district_id'));

                }else{

                    define('DISTRICT_ID' ,0);
                }

                // if(!empty($this->ci->session->userdata('type_question')))
                // {
                //    define('TYPE_QUESTION', $this->ci->session->userdata('type_question'));

                // }else{

                //     define('TYPE_QUESTION', 0);
                // }

            }else{

                if(LIBRARY == 'csr' and $q->row()->district_id == 0)
                {
                    // override for CSR Module

                    if(!empty($this->ci->session->userdata('district_id')))
                    {
                        define('DISTRICT_ID', $this->ci->session->userdata('district_id'));

                    }else{

                        define('DISTRICT_ID' ,0);
                    }

                }else{
                    define('DISTRICT_ID' ,$q->row()->district_id);
                }
            }


            define('BOOKSHELF_ROLE',$q->row()->group_member);

            define('GROUP_VIEWER',$q->row()->group_viewer);
            define('GROUP_MODERATOR',$q->row()->group_moderator);

            define('LIBRARY_USER', $q->row()->library);

            $this->ci->db->select('district_name, library_id');
            $q2 = $this->ci->db->get_where('tb_district2',array('district_id' => DISTRICT_ID , 'library_id'=> LIBRARY_ID  ));
            if($q2->row()->district_name){
                define('DISTRICT_NAME_XX', $q2->row()->district_name );
            }else{
                define('DISTRICT_NAME_XX', "VAMPIRE" );
            }



            /* define('NAME', $q->row()->first_name."&nbsp;".$q->row()->last_name."(".DISTRICT_NAME_XX.":".DISTRICT_ID.", LU:".LIBRARY_USER.", LL:".LIBRARY_ID.' R:'.ROLE_ID.")");*/
             define('NAME', $q->row()->first_name."&nbsp;".$q->row()->last_name);
             define('NAME2', $q->row()->first_name."&nbsp;".$q->row()->last_name);




        }else{

            return false;
        }

    }

    function get_user_permission2()
    {
        $this->ci->db->select('username, first_name, last_name, role, district_id, group_member, group_viewer, group_category, group_moderator, library');
        $q = $this->ci->db->get_where('tb_user_v2',array('id' => USER_ID));

        if($q->num_rows() > 0) {
            define('ROLE_ID',$q->row()->role);
            define('GROUP_CATEGORY',$q->row()->group_category);

            if($q->row()->role == 1){
                if(!empty($this->ci->session->userdata('district_id')))
                {
                    define('DISTRICT_ID', $this->ci->session->userdata('district_id'));
                }else{
                    define('DISTRICT_ID' ,0);
                }
            }else{
                if(LIBRARY == 'csr' and $q->row()->district_id == 0)
                {
                    // override for CSR Module
                    if(!empty($this->ci->session->userdata('district_id')))
                    {
                        define('DISTRICT_ID', $this->ci->session->userdata('district_id'));
                    }else{
                        define('DISTRICT_ID' ,0);
                    }
                }else{
                    define('DISTRICT_ID' ,$q->row()->district_id);
                }
            }

            define('BOOKSHELF_ROLE',$q->row()->group_member);
            define('GROUP_VIEWER',$q->row()->group_viewer);
            define('GROUP_MODERATOR',$q->row()->group_moderator);
            define('LIBRARY_USER', $q->row()->library);

            $this->ci->db->select('district_name, library_id');
            $q2 = $this->ci->db->get_where('tb_district2',array('district_id' => DISTRICT_ID , 'library_id'=> LIBRARY_ID  ));
            if($q2->row()->district_name){
                define('DISTRICT_NAME_XX', $q2->row()->district_name );
            }else{
                define('DISTRICT_NAME_XX', "VAMPIRE" );
            }

            define('NAME', $q->row()->first_name."&nbsp;".$q->row()->last_name);
            define('NAME2', $q->row()->first_name."&nbsp;".$q->row()->last_name);
        }else{
            return false;
        }
    }

    public function get_library()
    {
       
        //$q = $this->ci->db->get_where('tb_library', array('library_url' => str_replace('http:', '', str_replace('/','',base_url()))));
        
        //$q = $this->ci->db->get_where('tb_library', array('library_url' => $_SERVER['SERVER_NAME']));
        
        $this->ci->db->where('library_url' , $_SERVER['SERVER_NAME']);
        
        $this->ci->db->or_where('library_url' , 'www.'.$_SERVER['SERVER_NAME']);
        
        $q = $this->ci->db->get('tb_library');
        
        if($q->num_rows() == 0)
        {
            return false;
        }

        return (array)$q->row();
    }

    function generateRandomString($length = 30) {

        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';

        $charactersLength = strlen($characters);

        $randomString = '';

        for ($i = 0; $i < $length; $i++) {

            $randomString .= $characters[rand(0, $charactersLength - 1)];

        }
        return $randomString;
    }
	
    function getLibraryAsstes(){

    }

    function getTheme(){

    }

    function decryption($key)

    {

        $key = substr($key,30);



        return unserialize(base64_decode(base64_decode($key)));

    }



    function encryption($arr, $end_user)

    {

        $key = $this->generateRandomString(30);



        $arr['end_user'] = $end_user;

        $arr['key1'] = $this->generateRandomString(15);

        $arr['key4'] = $this->generateRandomString(15);

        $this->kshuffle($arr);



        $data = base64_encode(serialize($arr));

        $new_key = $key.base64_encode($data);

        return $new_key;

    }

    private function logging()
    {
        $postData = $this->ci->input->post();
        if(!empty($postData['input_password']))
        {
            $postData['input_password'] = '';

        }
        if(!empty($postData['password']))
        {
            $postData['password'] = '';

        }

        $insert_data = array(
            'user_id' => USER_ID,
            'url' => base_url().$_SERVER["REQUEST_URI"],
            'data' => json_encode($postData),
            'datetime' => date('Y-m-d H:i:s'),
            'ip_address' => $_SERVER["REMOTE_ADDR"]
        );
        $this->ci->db->insert('tb_transaction_log', $insert_data);
    }

    function httpPost($url, $params) {

        $postData = '';
        /*create name value pairs seperated by &*/
        foreach ($params as $k => $v) {
            $postData .= $k . '=' . $v . '&';
        }

        $postData = rtrim($postData, '&');

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_POST, count($postData));
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//        curl_setopt($ch, CURLOPT_CAINFO, '/path/to/cacert.pem');

        $output = curl_exec($ch);

//        var_dump($output); exit();
        curl_close($ch);
        return $output;
    }

    function authorize($permission = '')
    {
        $my_role = $this->ci->db->get_where('tb_user_role', array('user_id' => USER_ID));

        $authorities = array();
        foreach ($my_role->result() as $row)
        {
            $role = $this->ci->db->get_where('tb_role', array('id' => $row->role_id));
            if($role->num_rows() > 0)
            {
                $new_auth = json_decode($role->row()->permission);
                $authorities = array_merge($new_auth, $authorities);
            }
        }

//        $role = $this->ci->db->get_where('tb_role', array('id' => 2));
//        if($role->num_rows() > 0)
//        {
//            $new_auth = json_decode($role->row()->permission);
//            $authorities = array_merge($new_auth, $authorities);
//        }

        if(in_array($permission, $authorities))
        {
            return true;
        }

        return false;
    }

}
